#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <shamalloc.h>

int
main () {
  void* a; void* b; void* c;

  // break after zero allocations
  break_alloc(0);
  a = malloc(124);
  b = calloc(1, 124);
  c = realloc(a, 124);
  break_alloc(-1);
  printf("%16p, %16p, %16p\n", a, b, c);

  // break after one allocation.
  break_alloc(1);
  a = malloc(124);
  b = calloc(1, 124);
  c = realloc(a, 124);
  break_alloc(-1);
  printf("%16p, %16p, %16p\n", a, b, c);

  // malloc still works
  a = malloc(124);
  b = calloc(1, 124);
  c = realloc(a, 124);
  printf("%16p, %16p, %16p\n", a, b, c);


  return 0;
}
